package net.dabbit.servlet2;


import net.dabbit.entity.Cake; //蛋糕
import net.dabbit.entity.CakeCart;
import net.dabbit.entity.CakeDB; // 蛋糕数据库
import net.dabbit.configs.Config; //配置信息

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.*;
import java.io.IOException;
import java.util.List;



@WebServlet(name = "PurchaseServlet",urlPatterns="/PurchaseServlet")
public class PurchaseServlet extends HttpServlet {
    public static String LIST_CAKE_URL = "ListCakeServlet";//蛋糕列表选项 URL
    public static String CART_OF_CAKE = "CartServlet";//购物车跳转URL

    private static final long serialVersionUID = 1L;

    public void init() throws ServletException {//初始化函数
        LIST_CAKE_URL = new Config().getId("LIST_CAKE_URL"); //获得蛋糕列表的跳转URL
        CART_OF_CAKE = new Config().getId("CART_OF_CAKE");
    }
    public void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {

        String id = req.getParameter("id");//获得ID

        if(id==null){ //如果ID不存在，则跳转到蛋糕列表
            resp.sendRedirect(LIST_CAKE_URL);
            return;
        }


        HttpSession session = req.getSession();//获得当前的session，如果不存在的话就自动创建一个新的。//准确说，这里应该是新建一个session


        CakeCart shop_car; //新建个车子在超市里跑
        shop_car = new CakeCart();

        if(session.getAttribute("shopping_cart")!=null){//如果session里存着数据，就读出来。
            shop_car = (CakeCart) session.getAttribute("shopping_cart"); //获得session里的数据
        }

        session.setAttribute("shopping_cart",shop_car);//设置shopping cart到session里

        Cake cake = CakeDB.getCake(id);//获得要购买的蛋糕ID
        shop_car.add_cake(cake);//在购物车里添加cake

        Cookie cookie = new Cookie("JSESSIONID",session.getId());
        cookie.setMaxAge(60*60*24*30); //30天
        cookie.setPath("./");

        resp.addCookie(cookie);//设置cookie

        resp.sendRedirect(CART_OF_CAKE);//跳转到购物车
    }
}

